/**
 * This class contains a event. An event contains the name of the
 * event and eventual data. 
 */

 
/**
 * Constructor for events.
 * @param name The event that happened.
 * @param data The data of the event, can be undefined or null.
 * @throws Error if event is undefined, null or empty.
 */
function Event(event, data) {
	assertNotEmpty(event, "The event of the event is undefined, null or empty: " + name);
	
	this.event = event;
	this.data = data; 	
}


/**
 * Get the event.
 * @return The event.
 */
Event.prototype.getEvent = function() {
	return this.event;
}


/**
 * Get the data of the event.
 * @return The data, undefined if not set.
 */
Event.prototype.getData = function() {
	return this.data;
}
