/**
 * Constructs a image preloader.
 * @param images A array containing the source url for the images to preload.
 * @throws Error if images is undefined. 
 */
function ImagePreloader(images) {
	assertDefined(images, "Images to preload not defined");
	
	this.images = images;
	this.imagesLoaded = 0;
}


/**
 * Starts the preloading of images.
 */
ImagePreloader.prototype.start = function() {
	for (var i = 0; i < this.images.length; i++) {
		var image = new Image();
		image.src = this.images[i];
	}	
}