/**
 * This file can show messages to the user using windows. 
 */
 

// construction

 
/**
 * The instance of this class.
 */
MessageManager.instanceObject;
 
 
/**
 * Constructs a instance of this class. 
 */
function MessageManager() {
	this.initMessageWindow();
	
	// the window object used to show messages
	this.messageWindow;
}


/**
 * Returns the instance of this class. 
*/
MessageManager.instance = function() {
	if (!exists(MessageManager.instanceObject)) {
		 MessageManager.instanceObject = new MessageManager();
	}
	return MessageManager.instanceObject;
}


/**
 * Shows a error message.
 * @param message The message to set. 
 * @throws Error if message is undefined, null, empty or not a string. 
 */
MessageManager.prototype.showErrorMessage = function(errorMessage) {
	if (typeof errorMessage != "string") {
		throw new Error("Error message to set is not a string");
	}
	assertNotEmpty(errorMessage, "The error message to set is undefined, null or empty");
	var messageContainer = getElementWithAttribute(this.messageWindow.getHtmlCode(), "message", "name", "div");
	messageContainer.innerHTML = errorMessage;
	setClass(messageContainer, "error");
	this.messageWindow.setWindowTitle("Error");
	WindowManager.instance().activateWindow("messageWindow");
	this.messageWindow.adjustSizeToContent();
}


// implementation


/**
 * Initializes the window used for error messages. 
 */
MessageManager.prototype.initMessageWindow = function() {
	this.createMessageWindowCode();
}


/**
 * Creates the html code of a message window.
 */
MessageManager.prototype.createMessageWindowCode = function() {
	// create the content
	var container = document.createElement("div");
	container.style.width = "244px";
	var messageContainer = document.createElement("div");
	messageContainer.setAttribute("name", "message");
	messageContainer.style.margin = "10px";
	container.appendChild(messageContainer);
	
	var okButton = document.createElement("input");
	okButton.setAttribute("type", "button");
	okButton.setAttribute("value", "Ok");
	okButton.style.marginBottom = "10px";
	okButton.style.width = "75px";
	okButton.onclick = function() {
		WindowManager.instance().hideWindow("messageWindow");
	}
	var center = document.createElement("center");
	center.appendChild(okButton);
	container.appendChild(center);
	document.body.appendChild(container);
	
	this.messageWindow = createWindow(container, "messageWindow", "Message");
	WindowManager.instance().hideWindow("messageWindow");
	this.messageWindow.setResizable(false);
	this.messageWindow.setMinSize(0, 250);
	WindowManager.instance().setModalWindow(this.messageWindow);
}