/**
 * This class specifies the possible action events.  
 */
 

 /**
  * The action event fired when a action has been set. 
  */
var ACTION_SET = "actionSet";


/**
 * The action event fired when a action has been edited. 
 */
var ACTION_EDITED = "actionEdited";


/**
 * The event fired when a action from a alarm has been added to the action library.
 */
var ACTION_ADDED_TO_LIBRARY = "addedtoActionLibrary";


/**
 * The event fired when the mouse has been moved over a action table. 
 */
var MOUSE_MOVED_OVER_ACTION_TABLE = "mouseMovedOverActionTable";


/**
 * The event fired when the mouse has been moved out of the action table. 
 */
var MOUSE_MOVED_OUT_ACTION_TABLE = "mouseMovedOutOfActinoTable";


/**
 * The event fired when the mouse has been moved over a action row in a action table. 
 * When the mouse moves over a action the actions details are to be shown in the action detail section.
 */
var MOUSE_MOVED_OVER_ACTION_ROW = "mouseMovedOverActionRow";


/**
 * The event fired when a action row has been selected. 
 */
var ACTION_SELECTED = "actionSelected";


/**
 * The event fired when a action row has been deselected. 
 */
var ACTION_DESELECTED = "actionDeselected";


/**
 * The event fired when a action has been deleted.
 */
var ACTION_DELETED = "actionDeleted";


/**
 * The event fired when the currently marked row has been deleted.
 */
var MARKED_ACTION_DELETED = "markedActionDeleted";

