

/**
 * The tab section containing the tabs.
 */
var tabSection;


/**
 * Contains the name of the iframes that the user has no access to.
 */
var noAccessFrames = new Array();


/**
 * This is used to indicate the setup tab it should activate the given window. 
 */
var showWindow = "";


/**
 * Initializes the page.
 */
function init() {
	initTabs();
	setResizeListener();
	initEventListener()
}


/**
 * Inits the tabs
 */
function initTabs() {
	// get the sid
	var sid = getElementWithAttribute(document.body, "sid", "name", "input").value;
	
	var tabs = new Array();
	var tabIndex = 0;
	var MainProperties = createProperties();
	MainProperties[TAB_CLASS] = "tab summaryTab";
	if (getMasterMode()) {
		tabs[tabIndex] = {name: "MasterMain", text: "", url: "/?resource=statistics.summary&mode=getpage&page=summary&sid=" + sid, properties: MainProperties};
	}
	else {
		tabs[tabIndex] = {name: "Main", text: "", url: "/?resource=statistics.summary&mode=getpage&page=summary&sid=" + sid, properties: MainProperties};
	}
	tabIndex++;
	
	if (getMasterMode()) {
		var currentProbeProp = createProperties();
		currentProbeProp[TAB_CLASS] = "tab currentProbe";
		tabs[tabIndex] = {name: "Main", text: "", url: "/?resource=statistics.summary&mode=getpage&page=summary&sid=" + sid, properties: currentProbeProp};
		tabIndex++;
	}
		
	var TrafficStatisticsProperties = createProperties();
	TrafficStatisticsProperties[TAB_CLASS] = "tab trafficStatistics";
	TrafficStatisticsProperties[FRAME_CLASS] = "trafficStatisticsFrame";
	TrafficStatisticsProperties[ACTIVE_FRAME_CLASS] = "trafficStatisticsFrame";
	TrafficStatisticsProperties[INACTIVE_FRAME_CLASS] = "inactiveAppletFrame";
	TrafficStatisticsProperties[FRAME_SCROLLBAR] = "off";
	tabs[tabIndex] = {name: "TrafficStatistics", text: "", url: "/?resource=statistics&mode=getpage&page=applet&sid=" + sid, properties: TrafficStatisticsProperties}; 
	tabIndex++;
	
	var TrafficLogProperties = createProperties();
	TrafficLogProperties[TAB_CLASS] = "tab trafficLog";
	TrafficLogProperties[FRAME_CLASS] = "trafficLogFrame";
	TrafficLogProperties[ACTIVE_FRAME_CLASS] = "trafficLogFrame";
	TrafficLogProperties[INACTIVE_FRAME_CLASS] = "inactiveAppletFrame";
	TrafficLogProperties[FRAME_SCROLLBAR] = "off";
	tabs[tabIndex] = {name: "TrafficLog", text: "", url: "/?resource=datamanager&mode=getpage&page=logapplet&sid=" + sid, properties: TrafficLogProperties};
	tabIndex++;
	
	var SetupProperties = createProperties();
	SetupProperties[TAB_CLASS] = "tab setup";
	tabs[tabIndex] = {name: "Setup", text: "", url: "/?resource=probemanager&mode=getpage&page=setup&sid=" + sid, properties: SetupProperties};
	tabIndex++;
	
	var helpProperties = createProperties();
	helpProperties[TAB_CLASS] = "tab help";
	helpProperties[LOADING_IMAGE] = undefined;
	tabs[tabIndex] = {name: "Help", text: "", url: "doc/index.html", properties: helpProperties};
	tabIndex++;
	
	var feedbackProperties = createProperties();
	feedbackProperties[TAB_CLASS] = "tab feedback";
	feedbackProperties[LOADING_IMAGE] = undefined;
	tabs[tabIndex] = {name: "Feedback", text: "", url: "http://www.objectplanet.com/probe/feedback.html", properties: feedbackProperties};
	tabIndex++;	
		
	var licenseProperties = createProperties();
	licenseProperties[TAB_CLASS] = "inactive";
	licenseProperties[LOADING_IMAGE] = undefined;
	tabs[tabIndex] = {name: "License", text: "", url: "http://support.objectplanet.com/licenser/generate_probe_test_key.jsp?hostid=" + getHostId() + "&version=" + getVersion(), properties: licenseProperties};
	tabIndex++;
	
	// create the properties for the tabs
	var properties = new Array();
	properties[TABS_BAR] = false;
	
	tabSection = new TabSection(tabs, properties);
	tabSection.paint();
	
	// set help tab frame to use max. height - height of top menu, necessary for Firefox
	tabSection.getTab("Help").height = getWindowHeight(window) - 36 + "px";	
	tabSection.getTab("License").height = getWindowHeight(window) - 36 + "px";
	tabSection.getTab("Feedback").height = getWindowHeight(window) - 36 + "px";
	
	tabSection.activateTab(getMasterMode() ? "MasterMain" : "Main");
	addSearchField();	
	if (getMasterMode()) {
		hideSearchField();
	}
}


/**
 * Create the properties array for a tab.
 * @param name The name of the tab
 */
function createProperties() {
	var tabProperties = new Array();
	tabProperties[MOUSE_OVER_PROPERTY] = false;
	tabProperties[LOAD_ONCLICK] = true;
	tabProperties[FRAME_CLASS] = "tabFrame";
	tabProperties[LOADING_IMAGE] = "images/loading_big_blue.gif";
	tabProperties[LOADING_SCREEN_CLASS] = "tabLoadingScreen";
	tabProperties[MOUSE_OVER_PROPERTY] = true;
	tabProperties[MOUSE_OVER_LEFT_CLASS_PROPERTY] = "leftMouseOver";
	tabProperties[MOUSE_OVER_MIDDLE_CLASS_PROPERTY] = "middleMouseOver";
	tabProperties[MOUSE_OVER_RIGHT_CLASS_PROPERTY] = "rightMouseOver";
	tabProperties[MOUSE_OVER_MIDDLE_CLASS_ACTIVE_PROPERTY] = "middleMouseOverActive";
	
	return tabProperties
}


/**
 * Assigns the the onresize handler to dynamic resize the applets.
 * Due to problems in IE with assigning the onresize handler from inside
 * a iframe we have to do this here.
 */
function setResizeListener() {
	window.onresize = positionElements;
}

/**
 * Sets the position and size of the elements that need to be 
 * adjusted when the window has been resized.
 */
function positionElements() {
	if (isNoAccessTab()) {
		setActiveNoAccessFrameSize();
	}
	if (tabSection.isActive("TrafficStatistics") && window.frames["TrafficStatistics"].positionApplet) {
		window.frames["TrafficStatistics"].positionApplet();
	}
	else if (tabSection.isActive("TrafficLog") && window.frames["TrafficLog"].positionLogApplet) {
		window.frames["TrafficLog"].positionLogApplet();
	}
	else if (tabSection.isActive("Main") && window.frames["Main"].windowResized) {
		window.frames["Main"].windowResized();
	}
	else if (tabSection.isActive("MasterMain") && window.frames["MasterMain"].windowResized) {
		window.frames["MasterMain"].windowResized();
	}
	else if (tabSection.isActive("Setup") && window.frames["Setup"].windowResized) {
		window.frames["Setup"].windowResized();
	}
	else if (tabSection.isActive("Help")) {
		var parentWindow = window.parent;
		var iframeCode = getElementWithAttribute(parentWindow.document.body, "Help", "name", "iframe");
		var frameTopOffset = calculateTopOffset(iframeCode);
		var parentWindowHeight = getWindowHeight(top);
		var frameHeight = parentWindowHeight - frameTopOffset;
		iframeCode.style.height = frameHeight + "px";
	}
}


// noaccess


/** 
 * Returns true if a user has no access to a frame.
 * @param frame The name of the frame to check.
 */
function isNoAccess(name) {
	if (isDefined(noAccessFrames[name])) {
		return true;
	}
	return false;
}


/**
 * Returns true if the user has no access to the active tab.
 */
function isNoAccessTab() {
	if (!isDefined(tabSection.getActiveTab())) {
		return false;
	}
	
	if (!isDefined(tabSection.getActiveTab().getName())) {
		return false;
	}
	
	if (isDefined(noAccessFrames[tabSection.getActiveTab().getName()])) {
		return true;
	}
	return false;
}


/**
 * No access has been loded.
 * @param url The url of the page the noaccess.html is loaded into.
 */
function noAccessLoaded(url) {
	var page = getParameterValue(url + "", "page", "&");
	if ("summary" == page) {
		page = "Main";
	}
	else if ("applet" == page) {
		page = "TrafficStatistics";
		var logAppletFrame = getElementWithAttribute(window.document.body, "TrafficStatistics", "name", "iframe");
		setClass(logAppletFrame, "tabFrame");
		var tab = tabSection.getTab("TrafficStatistics");
		tab.properties[FRAME_CLASS] = "tabFrame";
		tab.properties[ACTIVE_FRAME_CLASS] = undefined;
		tab.properties[INACTIVE_FRAME_CLASS] = undefined;
	}
	else if ("logapplet" == page) {
		page = "TrafficLog";
		var logAppletFrame = getElementWithAttribute(window.document.body, "TrafficLog", "name", "iframe");
		setClass(logAppletFrame, "tabFrame");
		var tab = tabSection.getTab("TrafficLog");
		tab.properties[FRAME_CLASS] = "tabFrame";
		tab.properties[ACTIVE_FRAME_CLASS] = undefined;
		tab.properties[INACTIVE_FRAME_CLASS] = undefined;
	}
	else if ("setup" == page) {
		page = "Setup";
	}
	
	if (top.tabSection) {
		tabSection.getTab(page).doneLoading();
	}
	
	noAccessFrames[page] = true;
	setNoAccessFrameSize(page);
}


/**
 * Sets the size of the active noaccess tab.
 */
function setActiveNoAccessFrameSize() {
	setNoAccessFrameSize(tabSection.getActiveTab().getName());
}
 
 
/**
 * Sets the size of a noaccess frame.
 * @param name The name of the frame.
 */
function setNoAccessFrameSize(name) {
	var frame = getElementWithAttribute(document.body, name, "name", "iframe");
	if (!isDefined(frame) || isNull(frame)) {
		return;
	}
	
	var frameHeight = getWindowHeight(top) - calculateTopOffset(frame);
	frame.style.height = frameHeight + "px";
	
	var frameWidth = getWindowWidth(top) - calculateLeftOffset(frame);
	frame.style.width = frameWidth + "px";
}


// event processing


/**
 * Inits the event processing.
 */
function initEventListener() {
	var eventListener = new Listener();
	eventListener.addEvent("probeNameChanged", processProbeNameChangedEvent);
	// listen to tab activated events, we need to do this to start sending dummy requests
	// when the help, setup or log applet tab is activated
	eventListener.addEvent("tabActivated", processTabActivtedEvent);
	eventListener.addEvent("tabDeactivated", processTabDeactivatedEvent);
}


/**
 * Processes a probe name change event.
 * @param event The event to process.
 */
function processProbeNameChangedEvent(event)  {
	// replace the old probename in the title with the new one
	var oldName = event.getData()["oldProbeName"];
	var newName = event.getData()["newProbeName"];
	if (oldName == newName || isEmpty(oldName) || isEmpty(newName)) {
		return;
	}
	
	document.title = "Network Probe - [" + newName + "]";
}


/**
 * Processes a tab activated event. 
 * @param event The event to process. 
 */
function processTabActivtedEvent(event) {
	if ("Help".equalsIgnoreCase(event.getData())) {
		startKeepConnectionAlive();
	}
	else if ("Setup".equalsIgnoreCase(event.getData())) {
		startKeepConnectionAlive();
	}
	else if ("TrafficLog".equalsIgnoreCase(event.getData())) {
		startKeepConnectionAlive();
	}
}


/**
 * Processes a tab deactivated event. 
 * @param event The event to process. 
 */
function processTabDeactivatedEvent(event) {
	if ("Help".equalsIgnoreCase(event.getData())) {
		stopKeepConnectionAlive();
	}
	else if ("Setup".equalsIgnoreCase(event.getData())) {
		stopKeepConnectionAlive();
	}
	else if ("TrafficLog".equalsIgnoreCase(event.getData())) {
		stopKeepConnectionAlive();
	}
}
