

/**
 * The interval between sending the keep alive request. The session id
 * times out at the server after 30 min send so we send a dummy request every 29th minute.
 */
var KEEP_ALIVE_TIME = 1000*60*29;


/**
 * The repeater used to call the method to send a request. 
 */
var keepAliveRepeater = new Repeater(sendKeepAliveRequest, undefined, KEEP_ALIVE_TIME);


/**
 * The request to send to keep the session id valid. 
 */
var KEPP_ALIVE_REQUEST = "/?resource=probemanager&mode=set&command=keepalive&sid=";


/**
 * True if the sid has been added to the request.
 */
var sidAdded = false;


// services


/**
 * Starts the sending of the keep alive request
 */
function startKeepConnectionAlive() {
	keepAliveRepeater.start();
}


/**
 * Stops the sending of the keep alive request. 
 */
function stopKeepConnectionAlive() {
	keepAliveRepeater.stop();
}


/**
 * Sends a keep alive request. 
 */
function sendKeepAliveRequest() {
	if (!sidAdded) {
		KEPP_ALIVE_REQUEST = KEPP_ALIVE_REQUEST + getElementWithAttribute(top.document.body, "sid", "name", "input").value + "&";
		sidAdded = true;
	}
	loadXML(KEPP_ALIVE_REQUEST);
}