/**
 * This file implements the profile window.
 */
 
/**
 * Factory method to create profilewindows.
 * @returns A new profileWindwo object.
 * @param id The id of the table in the window. This is needed for catching events from the table.
 * @throws Error if id is undefined, null or empty.
 */
function createProfileWindow(id, tableId) {
	assertNotEmpty(id, "Id to set for the window is undefined, null or empty: " + id);
	
	var superInstance = createProbeWindow(id, tableId);
	var subInstance = new ProfileWindow(id, tableId);
	subInstance = createSubClass(superInstance, subInstance);
	subInstance.init();
	
	WindowManager.instance().removeWindow(superInstance);
	WindowManager.instance().registerNewWindow(subInstance);
	
	return subInstance;
}
 
 
/**
 * Constructs a profileWindow.
 */
function ProfileWindow() {
}


/**
 * Shows a window. This is overriden to clear any messages.
 */
ProfileWindow.prototype.show = function() {
	this.callSuper("show");
	ProfileManager.clearProfileMessage();
}