/**
 * The class to set to show the log selector frame.  
 */
var LOG_SELECTOR_FRAME_ACTIVE_CLASS = "activeLogSelector";


/**
 * The class to set to hide the log selector frame.
 */
var LOG_SELECTOR_FRAME_INACTIVE_CLASS = "inactiveLogSelector";


/**
 * The time of the log entry currently shown in the appplet.
 */
var currentTime = 0;


/**
 * True if the traffic applet has been stopped.
 */
var stoppedApplet = false;


/**
 * Get the exported data, used when a security exception is caught from the applet during data export
 */
function getExportData(index) {
	// microsoft internet explorer allows copying to clipboard
	if (navigator.appName.indexOf("Explorer") > -1) {
		text = document.TrafficApplet.getExportData(index-0);
		if (text.indexOf("\r\n") < 0) {
			regexp = new RegExp("\n", "g");
			text = text.replace(regexp, "\r\n");
		}
		if (window.clipboardData) {
			window.clipboardData.setData('text', text)
		}
		else {
			// opera may identify itself as IE but does not support
			// copying to clipboard
			showInNewWindow(index);
		}
	}
	// show the exported data in a browser window
	else {
		showInNewWindow(index);
	}
}


/**
 * Show the export data in new window. 
 */
function showInNewWindow(index) {
	alert('Your browser does not support clipboard access from applets.\r\nThe data will be shown in a new browser window,\r\nthen select view source and copy.');
	test = window.open('', '', '');		
	test.document.open();
	text = document.TrafficApplet.getExportData(index-0)						
	test.document.write(text);
	test.document.close();
}


/**
 * Get the exported interval data, used when a security exception is caught from the applet during data export
 */
function getIntervalExportData(index) {
	// microsoft internet explorer allows copying to clipboard
	if (navigator.appName.indexOf("Explorer") > -1) {
		text = document.TrafficApplet.getIntervalExportData(index-0);
		if (text.indexOf("\r\n") < 0) {
			regexp = new RegExp("\n", "g");
			text = text.replace(regexp, "\r\n");
		}
		window.clipboardData.setData('text', text)
	}
	// show the exported data in a browser window
	else {
		alert('Your browser does not support clipboard access from applets.\r\nThe data will be shown in a new browser window,\r\nthen select view source and copy.');
		w = window.open('', '', '');		
		w.document.open();
		text = document.TrafficApplet.getIntervalExportData(index - 0)	
		w.document.write(text);
		w.document.close();
	}
}


/**
 * Inits the log applet page.
 */
function initLogApplet() {
	if (getMasterMode()) {
		var slaveSelectorTable = getElementWithAttribute(top.frames["LogSelector"].document, "slaveSelectorTable", "name", "table");
		setClass(slaveSelectorTable, "active");
		var logSelector = getElementWithAttribute(window.parent.document.body, "LogSelector", "name", "iframe")
		logSelector.height = "70px";
		top.frames["LogSelector"].loadSlaves();
	}
	
	top.tabSection.getTab('TrafficLog').doneLoading(); 
	positionLogApplet();  
	if (top.tabSection.isActive("TrafficLog")) {
		showLogSelector();
	}
}


/**
 * Inits the applet page.
 */
function initApplet() {
	if (getMasterMode()) {
		var slaveSelectorTable = getElementWithAttribute(document.body, "slaveSelectorTable", "name", "table");
		setClass(slaveSelectorTable, "active");
		loadSlaves();
	}
	top.tabSection.getTab('TrafficStatistics').doneLoading(); 
	positionApplet();
}


/**
 * Called by the tabs when the applet or log applet page
 * has been activated.
 * @param name The name of the tab activated.
 */
function tabActivated(name) {
	if ("TrafficStatistics" == name) {
		hideLogSelector();
		positionApplet();
		loadSlaves();
	}	
	else if ("TrafficLog" == name) {
		// refresh the interval selection drop down box in the log applet page
		top.frames["LogSelector"].loadTimeStamps();
		showLogSelector();
		positionLogApplet();
		top.frames["LogSelector"].loadSlaves();
	}
	
	if (stoppedApplet && "TrafficStatistics" == name) {
		document.TrafficApplet.startUpdating();
	}
}


/**
 * Called by the tabs when the applet or log applet page
 * has been deactivated. Stops the updating of the applet.
 */
function tabDeactivated(name) {
	if ("TrafficStatistics" == name) {
		deactivateApplet()
	}	
	else if ("TrafficLog" == name) {
		hideLogSelector();
	}
}


/**
 * Stops updating of the TrafficStatistics applet.
 */
function deactivateApplet() {
	if (isDefined(document.TrafficApplet) && isDefined(document.TrafficApplet.stopUpdating)) {
		document.TrafficApplet.stopUpdating();
		stoppedApplet = true;
	}
}


/**
 * Sets the position and size of the applet according to the window size.
 */
function positionApplet() {
	if (isFirefoxMac() || isCamino()) {
		// if the browser used is Firefox on a mac or camino, the 
		// applet can not be resized due to problems in those two browsers
		return;
	}
	if (!top.tabSection.isActive("TrafficStatistics")) {
		return;
	}
	
	setAppletWidth("TrafficStatistics", "TrafficApplet");
	var slaveSelectorTable = getElementWithAttribute(document.body, "slaveSelectorTable", "name", "table");
	setAppletHeight("TrafficStatistics", "TrafficApplet", slaveSelectorTable.offsetHeight + 10);
	
	if (!isNull(getElementWithAttribute(top.document.body, "TrafficLog", "name", "iframe")) && !top.isNoAccess("TrafficLog")) {
		setAppletWidth("TrafficLog", "TrafficApplet");
	}
}


/**
 * POsitions the log applet according to the window size.
 */
function positionLogApplet() {
	if (isFirefoxMac() || isCamino()) {
		// if the browser used is Firefox on a mac or camino, the 
		// applet can not be resized due to problems in those two browsers
		return;
	}
	if (!top.tabSection.isActive("TrafficLog")) {
		return;
	}

	setAppletWidth("TrafficLog", "TrafficApplet");
	setAppletHeight("TrafficLog", "TrafficApplet", 0);
	
	if (!isNull(getElementWithAttribute(top.document.body, "TrafficStatistics", "name", "iframe"))) {
		setAppletWidth("TrafficStatistics", "TrafficApplet");
	}
}


/**
 * Set the height of a iframe a applet is in according to the window size.
 * @param name The name of the iframe.
 * @param appletName The name of the applet to set the width for.
 */
function setAppletWidth(name, appletName) {
	var parentWindow = window.parent;
	// this is a reference to the iframes html code in index.html
	var appletIframeCode = getElementWithAttribute(parentWindow.document.body, name, "name", "iframe");
	var frameLeftOffset = calculateLeftOffset(appletIframeCode);
	
	var parentWindowWidth = getWindowWidth(top);

	// in addition to the left offset also let be some space to the right
	var frameWidth = parentWindowWidth - frameLeftOffset - 20;
	if (frameWidth > 0) {
		appletIframeCode.style.width = frameWidth + "px";

		var applet = getElementWithAttribute(top.frames[name].document.body, appletName, "name", "applet");
		var appletTable = getElementWithAttribute(top.frames[name].document.body, "appletTable", "name", "table");
		if (isDefined(applet) && !isNull(appletTable)) {
			applet.style.width = frameWidth + "px";
			appletTable.style.width = frameWidth + "px";
		}
	}
}


/**
 * Set the width of a iframe a applet is in according to the window size.
 * @param name The name of the iframe.
 * @param appletName The name of the applet to set the height for.
 * @param difference The difference in pixels between the height of the iframe and the hieght of the applet to set. 
 */
function setAppletHeight(name, appletName, topOffset) {
	var parentWindow = window.parent;
	// this is a reference to the iframes html code in index.html
	var appletIframeCode = getElementWithAttribute(parentWindow.document.body, name, "name", "iframe");
	var frameTopOffset = calculateTopOffset(appletIframeCode);
	
	var parentWindowHeight = getWindowHeight(top);

	// in addition to the top offset also let be some space at the bottom
	var frameHeight = parentWindowHeight - frameTopOffset - 10;
	if (frameHeight > 0) {
		appletIframeCode.style.height = frameHeight + "px";
		
		var applet = getElementWithAttribute(top.frames[name].document.body, appletName, "name", "applet");
		var appletTable = getElementWithAttribute(top.frames[name].document.body, "appletTable", "name", "table");
		if (isDefined(applet) && !isNull(appletTable)) {
			applet.style.height = (frameHeight - topOffset) + "px";	
			appletTable.style.height = (frameHeight - topOffset) + "px";
		}
	}
}


/**
 * Shows the log selector iframe.
 */
function showLogSelector() {
	var logSelectorFrame = getElementWithAttribute(top.document.body, "LogSelector", "name", "iframe");
	setClass(logSelectorFrame, LOG_SELECTOR_FRAME_ACTIVE_CLASS);
}


/**
 * Hides the log selector iframe.
 */
function hideLogSelector() {
	var logSelectorFrame = getElementWithAttribute(top.document.body, "LogSelector", "name", "iframe");
	setClass(logSelectorFrame, LOG_SELECTOR_FRAME_INACTIVE_CLASS);
}


/**
 * Show the slave setup window in the setup screen.
 */
function addSlaves() {
	if (exists(top.frames["Setup"])) {
		// the frame has been loaded already, activate the tab and show the email config window
		top.tabSection.activateTab("Setup");
		top.frames["Setup"].showSlaveSetupWindow();
	}
	else {
		// the frame has not been loaded yet
		top.tabSection.activateTab("Setup");
		top.frames["Setup"].showWindow = "slaveSetup";
		top.showWindow = "slaveSetup";
	}
}


/**
 * Loads the slaves. 
 */
function loadSlaves() {
	var slaveSelectCell = getElementWithAttribute(document.body, "slaveSelectCell", "name", "td");
	setClass(slaveSelectCell, "inactive");
	var slaveloadingAnimationCell = getElementWithAttribute(document.body, "slaveloadingAnimationCell", "name", "td");
	setClass(slaveloadingAnimationCell, "active");
	getSlaveProbeManager().loadSlaves(slavesLoadedApplet);
}


/**
 * The slaves have been loaded, add them to the dropdown list. 
 * @param slaves The slaves loaded.  
 */
function slavesLoadedApplet(slaves) {
	var selectedValue = getSelectedSlave();
	clearSlaveSelector();
	var slaveSelect = getElementWithAttribute(document.body, "slaveSelect", "name", "select");
	var defaultOption = new Option("Select a probe", "");
	slaveSelect.add(defaultOption, undefined);
	var probeName = isEmpty(getProbeName()) ? "This probe" : (getProbeName() + " (this)");
	var masterProbeOption = new Option(probeName, "master");
	slaveSelect.add(masterProbeOption, undefined);
	for (var i = 0; i < slaves.length; i++) {
		var slaveName = isEmpty(slaves[i].getName()) ? slaves[i].getIpAddress() : slaves[i].getName();
		var option = new Option(slaveName, slaves[i].getIpAddress());
		slaveSelect.add(option, undefined);
	}
	var slaveloadingAnimationCell = getElementWithAttribute(document.body, "slaveloadingAnimationCell", "name", "td");
	setClass(slaveloadingAnimationCell, "inactive");
	var slaveSelectCell = getElementWithAttribute(document.body, "slaveSelectCell", "name", "td");
	setClass(slaveSelectCell, "active");
	selectInSelector(slaveSelect, selectedValue);
}


/**
 * A slaves has been selected in the slave selector. Show the slaves data in the applet.
 */
function showSlaveData() {
	var slaveSelect = getElementWithAttribute(document.body, "slaveSelect", "name", "select");
	var selectedSlave = slaveSelect.options[slaveSelect.selectedIndex].value;
	trafficStatisticsApplet().slaveSelected(selectedSlave);
}


/**
 * Clears the slaves dropdown field. 
 */
function clearSlaveSelector() {
	var slaveSelect = getElementWithAttribute(document.body, "slaveSelect", "name", "select");
	for (var i = slaveSelect.options.length; i >= 0; i--) {
		slaveSelect.remove(i);
	}
}	


/**
 * Gets the traffic statistics applet.
 */	
function trafficStatisticsApplet() {
	return top.frames["TrafficStatistics"].document.TrafficApplet;
}


/**
 * Returns the selected slave value.
 * @return The selected slave.
 */
function getSelectedSlave() {
	var slaveSelect = getElementWithAttribute(document.body, "slaveSelect", "name", "select");
	return slaveSelect.options[slaveSelect.selectedIndex].value;
}


/**
 * A slave has been selected in log applet page. Clear the applet
 * and reload the log time stamps from the selected slave.
 */
function slaveSelectedLogApplet() {
	top.frames["TrafficLog"].document.TrafficApplet.removeLogData();
	loadTimeStamps();
}