/**
 * This file provides functions for browser detection.
 * The functions have been tested with Firefox 2.0 
 * IE 6, Opera 8,5 and Camino 1.0.3
 */
 

/**
 * Returns true if the browser used is opera.
 */
function isOpera() {
	return navigator.userAgent.indexOf("Opera") >= 0;
}		
 

/**
 * Returns true if the browser used is Firefox.
 */
function isFirefox() {
	// in Opera one can choose if the browser shall identify as mozilla 
	if (isOpera()) {
		return false;
	}
	return navigator.userAgent.indexOf("Firefox") >= 0;
}


/**
 * Returns true if the browser used is Firefox on a Mac.
 */
function isFirefoxMac() {
	// in Opera one can choose if the browser shall identify as mozilla 
	if (isOpera()) {
		return false;
	}
	
	var index = navigator.userAgent.indexOf("Firefox");
	if (index == -1) {
		return false;
	}
	
	index = navigator.userAgent.indexOf("Macintosh");
	return index >= 0;
}


/**
 * Returns true if the browser used is Camino.
 */
function isCamino() {
	return navigator.userAgent.indexOf("Camino") >= 0;
}	


/**
 * Returns true if the browser used is Internett Explorer.
 */
function isIE() {
	// in Opera one can choose if the browser shall identify as Internett Explorer 
	if (isOpera()) {
		return false;
	}
	return navigator.userAgent.indexOf("MSIE") >= 0;
}


/**
 * Returns true if the browser used is Safari.
 */
function isSafari() {
	return navigator.userAgent.indexOf("Safari") >= 0;
}
